//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.action;

//===========================================================================
// import
//===========================================================================
import java.io.IOException;
import java.util.Locale;
import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.commons.logging.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;
import org.apache.commons.beanutils.*;

import java.util.*;

import jp.gr.java_conf.bugslife.selections.SelectionSet;
import jp.gr.java_conf.bugslife.user.*;
import jp.gr.java_conf.bugslife.form.*;
/**
 *<PRE>
 * 
 * UserEditActionクラス
 *
 *</PRE>
 * @version	0.0
 * @author	鰐川 正寛
 */
public final class UserEditAction2 extends BaseAction 
{
//===========================================================================
// attributes
//===========================================================================
	/**
	 * Log
	 */
	private Log log = LogFactory.getLog(this.getClass().getName());
//===========================================================================
// methods
//===========================================================================
	/**
	 * exevute
	 *
	 * @param mapping The ActionMapping used to select this instance
	 * @param actionForm The optional ActionForm bean for this request (if any)
	 * @param request The HTTP request we are processing
	 * @param response The HTTP response we are creating
	 *
	 * @exception Exception if business logic throws an exception
	 */
	public synchronized ActionForward doAction(ActionMapping mapping,
				 ActionForm form,
				 HttpServletRequest request,
				 HttpServletResponse response)
				throws Exception {
			
		/*  初期処理
		 */
		HttpSession session = getSession(request);	//sessioの取得
		UserInfo logonUser = (UserInfo)getAttribute(session,"UserInfo");	//ログインユーザの取得
		ActionForward forward = null;
		UserEditForm2 myForm = (UserEditForm2)form;	//formの取得
		
		//編集表示
		if (myForm.getAction().equals("edit")) {
			UserInfo user = (UserInfo)getAttribute(session,"EditUser");	//編集ユーザの取得
			PropertyUtils.copyProperties(myForm, user);
			
			myForm.setUserPermission(user.isForgiven(UserInfo.USER));
			myForm.setTesterPermission(user.isForgiven(UserInfo.TESTER));
			myForm.setDeveloperPermission(user.isForgiven(UserInfo.DEVELOPER));
			myForm.setProjectManagerPermission(user.isForgiven(UserInfo.PROJECT_MANAGER));
			myForm.setSystemManagerPermission(user.isForgiven(UserInfo.SYSTEM_MANAGER));
		
		//更新
		} else {
			UserInfo user = (UserInfo)getAttribute(session,"EditUser");	//編集ユーザの取得
			int uno = user.getUno();
			String uid = user.getUid();
			//データチェック
			ActionErrors errors = myForm.validate(mapping, request);
			if (!errors.empty()) {
				saveErrors(request, errors);
				return (new ActionForward(mapping.getInput()));
			}
			
			PropertyUtils.copyProperties(user, myForm);
			user.setUid(uid);	//uid
			//パーミッションセット
			int permission = 0;
			permission += myForm.getUserPermission() ? UserInfo.USER : 0;
			permission += myForm.getTesterPermission() ? UserInfo.TESTER : 0;
			permission += myForm.getDeveloperPermission() ? UserInfo.DEVELOPER : 0;
			permission += myForm.getProjectManagerPermission() ? UserInfo.PROJECT_MANAGER : 0;
			permission += myForm.getSystemManagerPermission() ? UserInfo.SYSTEM_MANAGER : 0;
			user.setPermission(permission);
			
			//更新
			user.update(logonUser.getUno());
	
			//ログインユーザ自身を更新した場合、セッションも更新
			if(user.getUno() == logonUser.getUno()){
	            session.setAttribute("UserInfo", user);	//セッションを更新
			}			
            session.setAttribute("EditUser", user);	//セッションを更新
//			SessionControl.initSession(session, logonUser);		//セッション情報を再取得
			
			//ユーザリストの再設定
			SelectionSet.setUserList(session.getServletContext(), true);

		}
		// Forward control to the specified success URI
		return mapping.findForward("success");
		
	}
}
